---
- name: Get Plex latest version URL
  shell: "curl -s 'https://plex.tv/downloads/details/1?build=linux-ubuntu-x86_64&channel=16&distro=ubuntu' | grep -Po '(?<=url=\\\")(\\S+)(?=\\\")'"
  args:
    warn: false
  register: shell_plex_latest_url
  changed_when: false

- name: Get Plex latest version
  shell: "curl -s 'https://plex.tv/downloads/details/1?build=linux-ubuntu-x86_64&channel=16&distro=ubuntu' | grep -Po '(?<=(\\\" version=\\\"))(\\S+)(?=(\\\"))'"
  args:
    warn: false
  register: shell_plex_latest_version
  changed_when: false

- name: Get Plex installed version
  become: true
  shell: "dpkg -s plexmediaserver | grep -Po '(?<=Version\\: )(\\S+)'"
  register: shell_plex_current_version
  changed_when: false
  failed_when: false

- name: Install/Update Plex
  when: shell_plex_current_version.rc != 0 or (shell_plex_current_version.stdout_lines[0] != shell_plex_latest_version.stdout_lines[0])
  become: true
  block:
    - name: Stop Plex process
      when: shell_plex_current_version.rc == 0
      service:
        name: plexmediaserver
        state: stopped

    - name: Install/Update Plex
      apt:
        deb: "{{ shell_plex_latest_url.stdout_lines[0] }}"

    # The next block is to install the agents that will make use of the XBMC
    # nfo files that I already got; thus saving me the time to rescrap and
    # retag my entire collection.
    - name: XBMC nfo files
      become: true
      become_user: plex
      block:
        - name: Clone XBMCnfoMoviesImporter.bundle repo
          git:
            repo: https://github.com/gboudreau/XBMCnfoMoviesImporter.bundle.git
            dest: "/var/lib/plexmediaserver/Library/Application Support/Plex Media Server/Plug-ins/XBMCnfoMoviesImporter.bundle"
            version: master
            clone: true
            update: true
            force: true

        - name: Clone XBMCnfoTVImporter.bundle repo
          git:
            repo: https://github.com/gboudreau/XBMCnfoTVImporter.bundle.git
            dest: "/var/lib/plexmediaserver/Library/Application Support/Plex Media Server/Plug-ins/XBMCnfoTVImporter.bundle"
            version: master
            clone: true
            update: true
            force: true

    - name: Start Plex process
      service:
        name: plexmediaserver
        state: started
        enabled: true
